module Bitmarkable
  class BitlyApiException < StandardError
  end

  class Bitly
    include HTTParty
    base_uri 'api.bitly.com'
    format :json

    def self.shorten(url)
      response = get('/v3/shorten', query: required_params.merge(longUrl: url))
      raise BitlyApiException,
            "#{response['status_code']}: #{response['status_text']}" unless response['status_code'] == 200
      response['data']['url']
    end

    def self.clicks(url)
      response = get('/v3/clicks', query: required_params.merge(shortUrl: url))
      raise BitlyApiException,
            "#{response['status_code']}: #{response['status_text']}" unless response['status_code'] == 200
      response['data']['clicks'][0]['user_clicks']
    end

    def self.required_params
      {version: "2.0.1", login: Bitmarkable.config.login, apiKey: Bitmarkable.config.api_key}
    end
  end
end
